'' very crappy implementation of a OV6620 module

con

' do not move these
PIN_Y0     =  8
PIN_Y1     =  9
PIN_Y2     = 10
PIN_Y3     = 11
PIN_Y4     = 12
PIN_Y5     = 13
PIN_Y6     = 14
PIN_Y7     = 15
' feel free to move these
PIN_RESET  = 16
PIN_HREF   = 17
PIN_VSYNC  = 18                              
PIN_PXLCLK = 19

con ARRAYSIZE = COLS * (ROWS+1)  ' resolution (as I said not very high, but you can get decent ascii art out of a terminal this way)
COLS = 68
ROWS = 28
var
byte padding
byte frame[ARRAYSIZE]
long framecog
pub start

bytefill(@frame, FINISH, ARRAYSIZE)
persist := 1

repeat
    framecog := cognew(@FrameGrab, @frame) + 1
until framecog

pub stop
    if persist and framecog
       cogstop(framecog~ - 1)
    
pub runonce(wait)
bytefill(@frame, FINISH, ARRAYSIZE)
persist := 0

repeat
    framecog := cognew(@FrameGrab, @frame) + 1
until framecog
if wait
   repeat until byte[@frame +constant(ARRAYSIZE-1)] <> FINISH
framecog~

pub pxladdr(xoffs,yy)  ' yy can be FALSE. if so, this returns the offset. if YY is something, return the ADDRESS of the coords, so for example, byte[cam.addr(13,20)]
    yy *= COLS
    result := @frame + xoffs + yy
pub pxl(offs)
    result := offs
    result += @frame
    result := byte[result]
pub setpxl(whatto,offs)
    offs += @frame
    byte[offs] := whatto & $FF
pub ofs(xx,yy) : offset  ' convert from offset to coords and back
    offset := (yy*COLS)+xx
pub x(offs) : coord
    coord := offs // COLS
pub y(offs) : coord
    coord := offs / COLS    
pub frm
    return @frame
con
DELIMITER = $FF                 ' indicate end of line
FINISH    = $FE                 ' indicates end of field (unused)

dat

' Grabs a VERY low res frame out of the OV6620 module, either stops itself when done, or goes back and does it all over again

FrameGrab     org     
              mov    addr,           par           ' predecrement address (because we need to) and store it
              add    addr,           #1
              add    maxsize,         par          ' see what the max address is
              sub    maxsize,         #65
              mov    dira,            mask_reset   ' makes sure they're all inputs except reset as far as this cog is concerned
              mov    outa,            #0           ' and make sure reset is low!
              
waitvsync
              mov     inval,                #FINISH
              wrbyte  inval,                addr
              mov     addr,                 par ' restore array address to first location
              add     addr,                 #1  ' restore array address to first location

              waitpeq mask_vsync,                 mask_vsync ' wait for vsync to cycle
              waitpne mask_vsync,                 mask_vsync ' wait for vsync to cycle
              jmp     #waithsync                 ' now that vsync is good, check hsync
              
waithsync     waitpne mask_href,                 mask_href     ' optional: wait for HREF to go down
              waitpeq mask_href,                 mask_href     ' wait for HREF to go up

              waitpne mask_href,                 mask_href     ' optional: wait for HREF to go down
              waitpeq mask_href,                 mask_href     ' wait for HREF to go up

              waitpne mask_href,                 mask_href     ' optional: wait for HREF to go down
              waitpeq mask_href,                 mask_href     ' wait for HREF to go up

              waitpne mask_href,                 mask_href     ' optional: wait for HREF to go down
              waitpeq mask_href,                 mask_href     ' wait for HREF to go up


shiftin
              'waitpne zero,                 mask_pxlclk  ' allow pixel clock go back high
              waitpne mask_pxlclk,          mask_pxlclk ' wait for pixel clock to settle
              mov     tempina,              ina     ' this is where stuff actually happens : read in the port
              mov     inval,                tempina ' this is where stuff actually happens : read in the port
              shr     inval,                #8  ' move the data to the low byte
              add     addr,                 #1  ' increment the destination address
              wrbyte  inval,                addr ' copy byte to main memory -- higher 2 bytes are ignored anyway

checkhsync
              mov     testval,              tempina
              and     testval,              mask_href   ' only concern self with the href pin
              tjnz    testval,              #shiftin    ' if it's not zero (pin high), go get another pixel



skipline2     waitpne mask_href,                 mask_href     ' optional: wait for HREF to go down
              waitpeq mask_href,                 mask_href     ' wait for HREF to go up

              waitpne mask_href,                 mask_href     ' optional: wait for HREF to go down
              waitpeq mask_href,                 mask_href     ' wait for HREF to go up

              waitpne mask_href,                 mask_href     ' optional: wait for HREF to go down
              waitpeq mask_href,                 mask_href     ' wait for HREF to go up

              waitpne mask_href,                 mask_href     ' optional: wait for HREF to go down
              waitpeq mask_href,                 mask_href     ' wait for HREF to go up

              waitpne mask_href,                 mask_href     ' optional: wait for HREF to go down
              waitpeq mask_href,                 mask_href     ' wait for HREF to go up

              waitpne mask_href,                 mask_href     ' optional: wait for HREF to go down
              waitpeq mask_href,                 mask_href     ' wait for HREF to go up



checkvsync     ' checkvsync doesn't work, i have to do the overflow check below -- anyone have any idea?
              or      tempina,              ina   ' double check
              mov     testval,              tempina         ' read ina again
              and     testval,              mask_vsync  ' only concern self with the vsync pin
              tjnz    testval,              #suicide'waitvsync    ' if it's not zer (pin high), go we're at another cycle


' if we're done with a line but not at a new page, add a line delimiter and keep going
doneline
              add      addr,              #1      ' add a delimiter...
              mov     inval,              #DELIMITER    ' ,,, to the byte array
              cmp     maxsize,            addr   wc ' amake sure we're not overflowing
         if_c jmp                         #suicide'waitvsync ' go get another line

              wrbyte  inval,              addr
              jmp                         #waithsync ' go get another line

suicide       test  persist,              persist wz ' see what's inside extrapar (tests to itself affects flags to see if it's 0 or not)
        if_nz jmp   #waitvsync
              cogid testval 
              cogstop testval


                     
                     
' RES statements don't work!!! (?) using presets for everything for now
                            
inval                   long    0
addr                    long    0

mask_vsync              long    |< PIN_VSYNC
mask_href               long    |< PIN_HREF
mask_pxlclk             long    |< PIN_PXLCLK
mask_reset              long    |< PIN_RESET
zero                    long    0
testval                 long    0
tempina                 long    0
linecnt                 long    0
maxsize                 long    ARRAYSIZE



persist                long    0 ' decides whether the cog is persistent or only grabbing one frame

fit 496